#######################
#### Start of File ####
#######################
# --------------------------------------------------------------- 
# Makefile Contents: Makefile for VBD Library components
# C/C++ Compiler Used: 
# Produced By: Doug Gaer
# File Creation Date: 09/16/1999
# Date Last Modified: 08/11/2000
# --------------------------------------------------------------- 
# --------------- Makefile Description and Details -------------- 
# --------------------------------------------------------------- 
# This makefile contains all the build dependency rules for the
# entire VBD library. 
# --------------------------------------------------------------- 

# Define the $(VBDDIR) macro in the main makefile for this application
# Setup path for VBD Base installation directory
# My directory path for the VBD class library.
VBDDIR = $(VBDPATH)

# Define the $(PATHSEP) macro in the main makefile for this application
# Macro for path separator
PATHSEP=/

# Define a path to the VBS library include files
VBDINCLUDE_PATH = $(VBDDIR)$(PATHSEP)include

# Build dependency rules
# ===============================================================
VBCRC32_DEP = $(VBDINCLUDE_PATH)$(PATHSEP)vbcrc32.h \
	$(VBDINCLUDE_PATH)$(PATHSEP)vbcrctab.h

VBDFPTR_DEP = $(VBDINCLUDE_PATH)$(PATHSEP)vbdtypes.h \
	$(VBDINCLUDE_PATH)$(PATHSEP)vbdfptr.h \
	$(VBDINCLUDE_PATH)$(PATHSEP)vbheader.h \
	$(VBDINCLUDE_PATH)$(PATHSEP)vbd_ver.h \
	$(VBDINCLUDE_PATH)$(PATHSEP)vbint32.h \
	$(VBDINCLUDE_PATH)$(PATHSEP)vbuint32.h

VBDBASE_DEP = $(VBDINCLUDE_PATH)$(PATHSEP)vbdtypes.h \
	$(VBDINCLUDE_PATH)$(PATHSEP)vbheader.h \
	$(VBDINCLUDE_PATH)$(PATHSEP)vbdfptr.h \
	$(VBDINCLUDE_PATH)$(PATHSEP)vbderror.h \
	$(VBDINCLUDE_PATH)$(PATHSEP)vbd_ver.h \
	$(VBDINCLUDE_PATH)$(PATHSEP)vbint32.h \
	$(VBDINCLUDE_PATH)$(PATHSEP)vbdbase.h \
	$(VBDINCLUDE_PATH)$(PATHSEP)vbcrc32.h \
	$(VBDINCLUDE_PATH)$(PATHSEP)vbuint32.h

VBDERROR_DEP = $(VBDINCLUDE_PATH)$(PATHSEP)vbderror.h

VBDSTATS_DEP = $(VBDINCLUDE_PATH)$(PATHSEP)vbdtypes.h \
	$(VBDINCLUDE_PATH)$(PATHSEP)vbheader.h \
	$(VBDINCLUDE_PATH)$(PATHSEP)vbdfptr.h \
	$(VBDINCLUDE_PATH)$(PATHSEP)vbderror.h \
	$(VBDINCLUDE_PATH)$(PATHSEP)vbd_ver.h \
	$(VBDINCLUDE_PATH)$(PATHSEP)vbint32.h \
	$(VBDINCLUDE_PATH)$(PATHSEP)vbdbase.h \
	$(VBDINCLUDE_PATH)$(PATHSEP)vbcrc32.h \
	$(VBDINCLUDE_PATH)$(PATHSEP)vbuint32.h \
	$(VBDINCLUDE_PATH)$(PATHSEP)vbdstats.h

VBFLOAT_DEP = $(VBDINCLUDE_PATH)$(PATHSEP)vbdtypes.h \
	$(VBDINCLUDE_PATH)$(PATHSEP)vbfloat.h

VBINT32_DEP = $(VBDINCLUDE_PATH)$(PATHSEP)vbdtypes.h \
	$(VBDINCLUDE_PATH)$(PATHSEP)vbint32.h

VBINT16_DEP = $(VBDINCLUDE_PATH)$(PATHSEP)vbdtypes.h \
	$(VBDINCLUDE_PATH)$(PATHSEP)vbint16.h

VBINT64_DEP = $(VBDINCLUDE_PATH)$(PATHSEP)vbdtypes.h \
	$(VBDINCLUDE_PATH)$(PATHSEP)vbdtyp64.h \
	$(VBDINCLUDE_PATH)$(PATHSEP)vbint64.h

VBUINT16_DEP = $(VBDINCLUDE_PATH)$(PATHSEP)vbdtypes.h \
	$(VBDINCLUDE_PATH)$(PATHSEP)vbuint16.h

VBUINT32_DEP = $(VBDINCLUDE_PATH)$(PATHSEP)vbdtypes.h \
	$(VBDINCLUDE_PATH)$(PATHSEP)vbuint32.h

VBUINT64_DEP = $(VBDINCLUDE_PATH)$(PATHSEP)vbdtypes.h \
	$(VBDINCLUDE_PATH)$(PATHSEP)vbdtyp64.h \
	$(VBDINCLUDE_PATH)$(PATHSEP)vbuint64.h

VBDFP64_DEP = $(VBDINCLUDE_PATH)$(PATHSEP)vbdtypes.h \
	$(VBDINCLUDE_PATH)$(PATHSEP)vbdfp64.h \
	$(VBDINCLUDE_PATH)$(PATHSEP)vbdtyp64.h \
	$(VBDINCLUDE_PATH)$(PATHSEP)vbhdr64.h \
	$(VBDINCLUDE_PATH)$(PATHSEP)vbheader.h \
	$(VBDINCLUDE_PATH)$(PATHSEP)vbd_ver.h \
	$(VBDINCLUDE_PATH)$(PATHSEP)vbint32.h \
	$(VBDINCLUDE_PATH)$(PATHSEP)vbint64.h \
	$(VBDINCLUDE_PATH)$(PATHSEP)vbuint64.h \
	$(VBDINCLUDE_PATH)$(PATHSEP)vbuint32.h

VBD64_DEP = $(VBDINCLUDE_PATH)$(PATHSEP)vbdtypes.h \
	$(VBDINCLUDE_PATH)$(PATHSEP)vbdtyp64.h \
	$(VBDINCLUDE_PATH)$(PATHSEP)vbhdr64.h \
	$(VBDINCLUDE_PATH)$(PATHSEP)vbdfp64.h \
	$(VBDINCLUDE_PATH)$(PATHSEP)vbheader.h \
	$(VBDINCLUDE_PATH)$(PATHSEP)vbderror.h \
	$(VBDINCLUDE_PATH)$(PATHSEP)vbd_ver.h \
	$(VBDINCLUDE_PATH)$(PATHSEP)vbint32.h \
	$(VBDINCLUDE_PATH)$(PATHSEP)vbd64.h \
	$(VBDINCLUDE_PATH)$(PATHSEP)vbcrc32.h \
	$(VBDINCLUDE_PATH)$(PATHSEP)vbint64.h \
	$(VBDINCLUDE_PATH)$(PATHSEP)vbuint64.h \
	$(VBDINCLUDE_PATH)$(PATHSEP)vbuint32.h

VBSTAT64_DEP = $(VBDINCLUDE_PATH)$(PATHSEP)vbdtypes.h \
	$(VBDINCLUDE_PATH)$(PATHSEP)vbdtyp64.h \
	$(VBDINCLUDE_PATH)$(PATHSEP)vbhdr64.h \
	$(VBDINCLUDE_PATH)$(PATHSEP)vbdfp64.h \
	$(VBDINCLUDE_PATH)$(PATHSEP)vbheader.h \
	$(VBDINCLUDE_PATH)$(PATHSEP)vbderror.h \
	$(VBDINCLUDE_PATH)$(PATHSEP)vbd_ver.h \
	$(VBDINCLUDE_PATH)$(PATHSEP)vbint32.h \
	$(VBDINCLUDE_PATH)$(PATHSEP)vbd64.h \
	$(VBDINCLUDE_PATH)$(PATHSEP)vbcrc32.h \
	$(VBDINCLUDE_PATH)$(PATHSEP)vbint64.h \
	$(VBDINCLUDE_PATH)$(PATHSEP)vbuint64.h \
	$(VBDINCLUDE_PATH)$(PATHSEP)vbuint32.h \
	$(VBDINCLUDE_PATH)$(PATHSEP)vbstat64.h 
# --------------------------------------------------------------- 
#####################
#### End of File ####
#####################

